<script setup>
import { ref, defineProps, reactive } from 'vue';
import { useThemeStore } from "../stores/theme";
import { useUserStore } from "../stores/user";
// import AuthService from "../services/auth.service";
// import axios from "axios";
import ThemeSwitcher from '../components/shared/ThemeSwitcher.vue'

const themeStore = useThemeStore();
const userStore = useUserStore();
// const authService = AuthService


const loading = ref(false)
const error = ref(false)
const registerError = ref(null)
const loginError = reactive(
    {
      username: [],
      password: [],
    }
)


const registerMsg = ref(null)

const active = ref(false)
const registering = ref(false)

const user = reactive(
    {username: null, email: null, password: null, passwordConfirmation: null}
)

const resetLoginError = () => {
  loginError.username = []
  loginError.password = []
}

const login = async () => {
  resetLoginError()
  error.value = false
  loading.value = true
  let isValidate = true

  if (user.username.length === 0) {
    loginError.username.push('Nom d\'utilisateur obligatoire')
    isValidate = false
  }
  if (user.username.length <= 4) {
    loginError.username.push('Le nom d\'utilisateur doit contenir au moins 4 caractères')
    isValidate = false
  }
  if (user.password === '') {
    loginError.password.push('Mot de passe obligatoire')
    isValidate = false
  }
  if (user.password.length < 6) {
    loginError.password.push('Le mot de passe doit contenir au moins 6 caractères')
    isValidate = false
  }

  if (isValidate) {
    const response = await userStore.login(user)
    if (response === true) {
      active.value = false
    } else {
      active.value = true
      error.value = true
    }
  }
  loading.value = false
}

const register = async () => {
  loading.value = true
  const response = await userStore.register(user)

  loading.value = false
  if (response.success) {
    registerMsg.value = response.message
  } else {
    console.log(response.data);
    registerError.value = {
      username: response.data.username,
      email: response.data.email,
      password: response.data.password,
      password_c: response.data.password_c,
    }
    console.log(registerError.value);
  }
}

const logout = () => {
  userStore.logout()
  active.value = false
}



</script>

<template>
  <div class="">
    <button @click="active = !active" type="button"
            :class="themeStore.dark ? 'focus:ring-gray-600 text-gray-400 hover:bg-gray-700' : 'text-gray-700'"
            class="flex items-center mr-3 text-sm p-2 rounded-full md:mr-0 " id="user-menu-button" aria-expanded="false" data-dropdown-toggle="dropdown1">
      <span class="sr-only">Ouvrir le menu de l'utilisateur</span>
      <span v-if="!userStore.isUserLoggedIn">Compte</span>
      <span v-else class="px-1">{{ userStore.user.username }}</span>
      <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
        <path stroke-linecap="round" stroke-linejoin="round" d="M5.121 17.804A13.937 13.937 0 0112 16c2.5 0 4.847.655 6.879 1.804M15 10a3 3 0 11-6 0 3 3 0 016 0zm6 2a9 9 0 11-18 0 9 9 0 0118 0z" />
      </svg>
    </button>
    <!-- Dropdown menu -->
    <div v-if="userStore.isUserLoggedIn" :class="active ? '' : 'hidden',
          themeStore.leftHanded ? 'md:right-[calc(100%-150px)]' : 'md:left-[calc(100%-136px)]',
          themeStore.dark ? 'bg-gray-700 divide-gray-600' : 'bg-white divide-gray-100'"
         class="md:top-[calc(100%-15px)] absolute z-50 my-4 text-base list-none rounded divide-y shadow" id="dropdown1">

      <ul class="py-1" aria-labelledby="dropdown">
        <li v-if="userStore.user.role === 'admin'">
          <router-link to="/dashboard"
             :class="themeStore.dark ? 'hover:bg-gray-600 text-gray-200 hover:text-white' : 'text-gray-700 hover:bg-gray-100'"
             class="block py-2 px-4 text-sm">Dashboard</router-link>
        </li>
        <li>
          <a href="#"
             :class="themeStore.dark ? 'hover:bg-gray-600 text-gray-200 hover:text-white' : 'text-gray-700 hover:bg-gray-100'"
             class="block py-2 px-4 text-sm">Profil</a>
        </li>
        <li>
          <a @click="logout"
             :class="themeStore.dark ? 'hover:bg-gray-600 text-gray-200 hover:text-white' : 'text-gray-700 hover:bg-gray-100'"
             class="block py-2 px-4 text-sm">Déconnexion</a>
        </li>
        <li>
          <ThemeSwitcher/>
        </li>
      </ul>
    </div>

    <div v-if="!userStore.isUserLoggedIn"
         :class="active ? '' : 'hidden',
          themeStore.leftHanded ? 'md:right-[calc(100%-300px)]' : 'md:left-[calc(100%-320px)]',
          themeStore.dark ? 'bg-gray-800 border-gray-700' : 'bg-white border-gray-200'"
         class="absolute md:top-[calc(100%-10px)] p-4 max-w-sm rounded-lg border shadow-md sm:p-6 lg:p-8">
      <form @submit.prevent="login" v-if="!registering">
        <div class="space-y-3">
        <h5 :class="themeStore.dark ? 'text-white' : 'text-gray-900'" class="text-xl font-medium">Accédez à votre compte</h5>
        <div v-show="error">
          <p class="text-center text-red-500 text-xs italic">Identifiants incorrect</p>
        </div>

          <div>
            <label for="username"
                   :class="themeStore.dark ? 'text-gray-300' : 'text-gray-900'"
                   class="block mb-2 text-sm font-medium">Nom d'utilisateur</label>
            <input v-model="user.username" type="text" name="username" id="username"
                   :class="themeStore.dark ? 'bg-gray-600 border-gray-500 placeholder-gray-400 text-white' : 'bg-gray-50 border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500'"
                   class="border text-sm rounded-lg block w-full p-2.5 " placeholder="Utilisateur" required>
            <div v-if="loginError !== null && loginError.username !== null">
              <p v-for="message in loginError.username" class="text-center text-red-500 text-xs italic">{{message}}</p>
            </div>
          </div>
          <div>
            <label for="password"
                   :class="themeStore.dark ? 'text-gray-300' : 'text-gray-900'"
                   class="block mb-2 text-sm font-medium">Mot de passe</label>
            <input v-model="user.password" type="password" name="password" id="password" placeholder="••••••••"
                   :class="themeStore.dark ? 'bg-gray-600 border-gray-500 placeholder-gray-400 text-white' : 'bg-gray-50 border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500'"
                   class="border text-sm rounded-lg block w-full p-2.5 " required>
            <div v-if="loginError !== null && loginError.password !== null">
              <p v-for="message in loginError.password" class="text-center text-red-500 text-xs italic">{{message}}</p>
            </div>
          </div>
<!--          {{userStore.status}}-->
          <button
              :class="themeStore.dark ? 'bg-blue-600 hover:bg-blue-700 focus:ring-blue-800' : 'text-white bg-blue-700 hover:bg-blue-800 focus:ring-blue-300 focus:ring-blue-300'"
              class="w-full mt-2  focus:ring-4 focus:outline-none font-medium rounded-lg text-sm px-5 py-2.5 text-center">
            <div v-if="loading">
              <svg class="w-8 h-8 mr-2 text-gray-200 animate-spin dark:text-gray-600 fill-blue-600" viewBox="0 0 100 101" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path d="M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z" fill="currentColor"/>
                <path d="M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z" fill="currentFill"/>
              </svg>
              <span>Connexion en cour</span>
            </div>
            <span v-else>Connexion</span>
          </button>
          <div :class="themeStore.dark ? 'text-gray-300' : 'text-gray-500'" class="text-sm font-medium">
            Pas encore de compte? <a @click="registering = !registering" class="hover:cursor-pointer text-blue-700 hover:underline dark:text-blue-500">S'inscrire</a>
          </div>
        </div>

      </form>


          <!--REGISTER-->
      <form @submit.prevent="register" v-else class="space-y-3">
<!--        {{registerError}}-->
        <h5 :class="themeStore.dark ? 'text-white' : 'text-gray-900'" class="text-xl font-medium">Création de votre compte</h5>
        <div>
          <label for="username" :class="themeStore.dark ? 'text-gray-300' : 'text-gray-900'" class="block mb-2 text-sm font-medium">Nom d'utilisateur</label>
          <input v-model="user.username" type="text" name="username"
                 :class="themeStore.dark ? 'bg-gray-600 border-gray-500 placeholder-gray-400 text-white' : 'bg-gray-50 border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500'"
                 class="border text-sm rounded-lg block w-full p-2.5" placeholder="utilisateur" required>
<!--          {{registerError}}-->
          <div v-if="registerError !== null && registerError.username !== null">
            <p v-for="message in registerError.username" class="text-center text-red-500 text-xs italic">{{message}}</p>
          </div>
        </div>
        <div>
          <label for="username" :class="themeStore.dark ? 'text-gray-300' : 'text-gray-900'" class="block mb-2 text-sm font-medium">Adresse email</label>
          <input v-model="user.email" type="text" name="email"
                 :class="themeStore.dark ? 'bg-gray-600 border-gray-500 placeholder-gray-400 text-white' : 'bg-gray-50 border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500'"
                 class="border text-sm rounded-lg block w-full p-2.5"  placeholder="votre@adresse.mail" required>
          <div v-if="registerError !== null && registerError.email !== null">
            <p v-for="message in registerError.email" class="text-center text-red-500 text-xs italic">{{message}}</p>
          </div>
        </div>
        <div>
          <label for="password" :class="themeStore.dark ? 'text-gray-300' : 'text-gray-900'" class="block mb-2 text-sm font-medium">Mot de passe</label>
          <input v-model="user.password" type="password" name="password" placeholder="••••••••"
                 :class="themeStore.dark ? 'bg-gray-600 border-gray-500 placeholder-gray-400 text-white' : 'bg-gray-50 border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500'"
                 class="border text-sm rounded-lg block w-full p-2.5" required>
          <div v-if="registerError !== null && registerError.password !== null">
            <p v-for="message in registerError.password" class="text-center text-red-500 text-xs italic">{{message}}</p>
          </div>
        </div>
        <div>
          <label for="password" :class="themeStore.dark ? 'text-gray-300' : 'text-gray-900'" class="block mb-2 text-sm font-medium">Confirmation du mot de passe</label>
          <input v-model="user.passwordConfirmation" type="password" name="password_c" placeholder="••••••••"
                 :class="themeStore.dark ? 'bg-gray-600 border-gray-500 placeholder-gray-400 text-white' : 'bg-gray-50 border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500'"
                 class="border text-sm rounded-lg block w-full p-2.5" required>
          <div v-if="registerError !== null && registerError.password_c !== null">
            <p v-for="message in registerError.password_c" class="text-center text-red-500 text-xs italic">{{message}}</p>
          </div>
        </div>
          <span v-if="registerMsg">{{registerMsg}}</span>
        <button
                :class="themeStore.dark ? 'bg-blue-600 hover:bg-blue-700 focus:ring-blue-800' : 'text-white bg-blue-700 hover:bg-blue-800 focus:ring-blue-300'"
                class="w-full focus:ring-4 focus:outline-none font-medium rounded-lg text-sm px-5 py-2.5 text-center">
          <span v-if="loading">
            <svg class="w-8 h-8 mr-2 text-gray-200 animate-spin dark:text-gray-600 fill-blue-600" viewBox="0 0 100 101" fill="none" xmlns="http://www.w3.org/2000/svg">
              <path d="M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z" fill="currentColor"/>
              <path d="M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z" fill="currentFill"/>
            </svg>
            Création en cours</span>
          <span v-else>Inscription</span>
        </button>
        <div :class="themeStore.dark ? 'text-gray-300' : 'text-gray-500'" class="text-sm font-medium">
          Vous avez déjà un compte? <a @click="registering = !registering" :class="themeStore.dark ? 'text-blue-500' : 'text-blue-700'" class="hover:cursor-pointer hover:underline">Connexion</a>
        </div>
      </form>

    </div>
    <!--  </ul>-->
  </div>
</template>


<!--<style lang="scss">-->
<!--.logged-in-dropdown {-->
<!--  transform: translateX(-25%);-->
<!--  top: calc(100% - 10px);-->
<!--  right: calc(100% - 300px);-->
<!--}-->
<!--</style>-->